Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobPage.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobPage.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobPage.cs	(revision 12516)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class JobPage {
+    public int TotalJobs { get; set; }
+    public IEnumerable<Job> Jobs { get; set; }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Task.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Task.cs	(revision 12515)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Task.cs	(revision 12516)
@@ -25,4 +25,7 @@
   public class Task {
     public Guid Id { get; set; }
+    public Guid JobId { get; set; }
+    public string JobName { get; set; }
+    public long TotalTime { get; set; }
     public double CalculatingTime { get; set; }
     public double WaitingTime { get; set; }
@@ -36,4 +39,7 @@
     public string State { get; set; }
     public Guid? LastClientId { get; set; }
+    public string LastClientName { get; set; }
+    public Guid UserId { get; set; }
+    public string UserName { get; set; }
     public DateTime? StartTime { get; set; }
     public DateTime? EndTime { get; set; }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskPage.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskPage.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskPage.cs	(revision 12516)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class TaskPage {
+    public int TotalTasks { get; set; }
+    public IEnumerable<Task> Tasks { get; set; }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskStateCount.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskStateCount.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskStateCount.cs	(revision 12516)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class TaskStateCount {
+    public string State { get; set; }
+    public int Count { get; set; }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JavascriptUtils.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JavascriptUtils.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JavascriptUtils.cs	(revision 12516)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Services.WebApp.Status.WebApi {
+  public static class JavascriptUtils {
+    public static long ToTimestamp(DateTime input) {
+      var epoch = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);
+      var time = input.Subtract(new TimeSpan(epoch.Ticks));
+      return time.Ticks / 10000;
+    }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JobController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JobController.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JobController.cs	(revision 12516)
@@ -0,0 +1,150 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Access;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DA = HeuristicLab.Services.Hive.DataAccess;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+
+  [Authorize]
+  public class JobController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    private IUserManager UserManager {
+      get { return ServiceLocator.Instance.UserManager; }
+    }
+
+    private IRoleVerifier RoleVerifier {
+      get { return ServiceLocator.Instance.RoleVerifier; }
+    }
+
+    public DT.JobDetails GetJobDetails(Guid id) {
+      using (var pm = PersistenceManager) {
+        var dimJobDao = pm.DimJobDao;
+        var factTaskDao = pm.FactTaskDao;
+        return pm.UseTransaction(() => {
+          var job = dimJobDao.GetById(id);
+          if (job != null) {
+            var timeData = factTaskDao.GetByJobId(id).GroupBy(x => x.JobId).Select(x => new {
+              AvgTransferringTime = (long)x.Average(y => y.TransferTime),
+              MinCalculatingTime = (long)x.Min(y => y.CalculatingTime),
+              MaxCalculatingTime = (long)x.Max(y => y.CalculatingTime),
+              AvgCalculatingTime = (long)x.Average(y => y.CalculatingTime),
+              TotalCalculatingTime = (long)x.Sum(y => y.CalculatingTime),
+              TotalWaitingTime = (long)x.Sum(y => y.WaitingTime)
+            }).FirstOrDefault();
+            DateTime endTime = job.DateCompleted ?? DateTime.Now;
+            long totalTime = (long)(endTime - job.DateCreated).TotalSeconds;
+            return new DT.JobDetails {
+              Id = job.JobId,
+              Name = job.JobName,
+              UserId = job.UserId,
+              UserName = job.UserName,
+              DateCreated = job.DateCreated,
+              DateCompleted = job.DateCompleted,
+              TotalTasks = job.TotalTasks,
+              CompletedTasks = job.CompletedTasks,
+              AvgTransferringTime = timeData != null ? timeData.AvgTransferringTime : 0,
+              AvgCalculatingTime = timeData != null ? timeData.AvgCalculatingTime : 0,
+              MinCalculatingTime = timeData != null ? timeData.MinCalculatingTime : 0,
+              MaxCalculatingTime = timeData != null ? timeData.MaxCalculatingTime : 0,
+              TotalCalculatingTime = timeData != null ? timeData.TotalCalculatingTime : 0,
+              TotalWaitingTime = timeData != null ? timeData.TotalWaitingTime : 0,
+              TotalTime = totalTime,
+              TasksStates = factTaskDao.GetByJobId(id)
+                            .GroupBy(x => x.TaskState)
+                            .Select(x => new DT.TaskStateCount {
+                              State = x.Key.ToString(),
+                              Count = x.Count()
+                            }).ToList()
+            };
+          }
+          return null;
+        });
+      }
+    }
+
+    public DT.JobPage GetJobs(int page, int size, bool completed = false) {
+      return GetJobsByUserId(UserManager.CurrentUserId, page, size, completed);
+    }
+
+    public DT.JobPage GetJobsByUserId(Guid id, int page, int size, bool completed = false) {
+      if (id != UserManager.CurrentUserId) {
+        RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+      }
+      using (var pm = PersistenceManager) {
+        var dimJobDao = pm.DimJobDao;
+        return pm.UseTransaction(() => {
+          var jobs = dimJobDao.GetByUserId(id).Where(x => completed ? (x.DateCompleted != null) : (x.DateCompleted == null));
+          return new DT.JobPage {
+            TotalJobs = jobs.Count(),
+            Jobs = jobs.OrderByDescending(x => x.DateCompleted ?? DateTime.MaxValue)
+              .Skip((page - 1) * size)
+              .Take(size)
+              .Select(x => ConvertToDT(x))
+              .ToList()
+          };
+        });
+      }
+    }
+
+    public IEnumerable<DT.Job> GetAllJobs(bool completed) {
+      return GetAllJobsByUserId(UserManager.CurrentUserId, completed);
+    }
+
+    public IEnumerable<DT.Job> GetAllJobsByUserId(Guid id, bool completed) {
+      if (id != UserManager.CurrentUserId) {
+        RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+      }
+      using (var pm = PersistenceManager) {
+        var dimJobDao = pm.DimJobDao;
+        return pm.UseTransaction(() => {
+          return dimJobDao.GetByUserId(id)
+            .Where(x => completed ? (x.DateCompleted != null) : (x.DateCompleted == null))
+            .Select(x => ConvertToDT(x))
+            .ToList();
+        });
+      }
+    }
+
+    private DT.Job ConvertToDT(DA.DimJob job) {
+      return new DT.Job {
+        Id = job.JobId,
+        Name = job.JobName,
+        UserId = job.UserId,
+        UserName = job.UserName,
+        DateCreated = job.DateCreated,
+        DateCompleted = job.DateCompleted,
+        TotalTasks = job.TotalTasks,
+        CompletedTasks = job.CompletedTasks
+      };
+    }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs	(revision 12516)
@@ -0,0 +1,154 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Access;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DA = HeuristicLab.Services.Hive.DataAccess;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+  public class TaskController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    private IUserManager UserManager {
+      get { return ServiceLocator.Instance.UserManager; }
+    }
+
+    private IRoleVerifier RoleVerifier {
+      get { return ServiceLocator.Instance.RoleVerifier; }
+    }
+
+    [HttpPost]
+    public DT.TaskPage GetTasksByJobId(Guid id, int page, int size, IEnumerable<string> states) {
+      using (var pm = PersistenceManager) {
+        var dimJobDao = pm.DimJobDao;
+        var dimClientDao = pm.DimClientDao;
+        var factTaskDao = pm.FactTaskDao;
+
+        DA.DimJob job = pm.UseTransaction(() => dimJobDao.GetById(id));
+        if (job == null) {
+          throw new ArgumentException("invalid job id");
+        }
+        if (job.UserId != UserManager.CurrentUserId) {
+          RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+        }
+
+        return pm.UseTransaction(() => {
+          var tasks = factTaskDao.GetByJobId(id).Where(x => states.Contains(x.TaskState.ToString()));
+          return new DT.TaskPage {
+            TotalTasks = tasks.Count(),
+            Tasks = (from factTask in tasks
+                     join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
+                     join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
+                       dimClient.Id into taskClientJoin
+                     from a in taskClientJoin.DefaultIfEmpty()
+                     let startTime = factTask.StartTime ?? DateTime.Now
+                     let endTime = factTask.EndTime ?? DateTime.Now
+                     select new DT.Task {
+                       Id = factTask.TaskId,
+                       JobId = factTask.JobId,
+                       JobName = dimJob.JobName,
+                       TotalTime = (long)(endTime - startTime).TotalSeconds,
+                       CalculatingTime = factTask.CalculatingTime,
+                       WaitingTime = factTask.WaitingTime,
+                       TransferTime = factTask.TransferTime,
+                       InitialWaitingTime = factTask.InitialWaitingTime,
+                       NumCalculationRuns = factTask.NumCalculationRuns,
+                       NumRetries = factTask.NumRetries,
+                       CoresRequired = factTask.CoresRequired,
+                       MemoryRequired = factTask.MemoryRequired,
+                       Priority = factTask.Priority,
+                       State = factTask.TaskState.ToString(),
+                       LastClientId = factTask.LastClientId,
+                       LastClientName = a != null ? a.Name : string.Empty,
+                       UserId = dimJob.UserId,
+                       UserName = dimJob.UserName,
+                       StartTime = factTask.StartTime,
+                       EndTime = factTask.EndTime,
+                       Exception = factTask.Exception
+                     })
+              .Skip((page - 1) * size)
+              .Take(size)
+              .ToList()
+          };
+        });
+      }
+    }
+
+    [HttpPost]
+    public DT.TaskPage GetTasksByClientId(Guid id, int page, int size, IEnumerable<string> states) {
+      bool isAdministrator = User.IsInRole(HiveRoles.Administrator);
+      using (var pm = PersistenceManager) {
+        var dimJobDao = pm.DimJobDao;
+        var dimClientDao = pm.DimClientDao;
+        var factTaskDao = pm.FactTaskDao;
+
+        return pm.UseTransaction(() => {
+          var tasks = factTaskDao.GetByClientId(id).Where(x => states.Contains(x.TaskState.ToString()));
+          return new DT.TaskPage {
+            TotalTasks = tasks.Count(),
+            Tasks = (from factTask in tasks
+                     join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
+                     join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
+                       dimClient.Id into taskClientJoin
+                     from a in taskClientJoin.DefaultIfEmpty()
+                     let startTime = factTask.StartTime ?? DateTime.Now
+                     let endTime = factTask.EndTime ?? DateTime.Now
+                     select new DT.Task {
+                       Id = isAdministrator ? factTask.TaskId : default(Guid),
+                       JobId = isAdministrator ? factTask.JobId : default(Guid),
+                       JobName = isAdministrator ? dimJob.JobName : string.Empty,
+                       TotalTime = (long)(endTime - startTime).TotalSeconds,
+                       CalculatingTime = factTask.CalculatingTime,
+                       WaitingTime = factTask.WaitingTime,
+                       TransferTime = factTask.TransferTime,
+                       InitialWaitingTime = factTask.InitialWaitingTime,
+                       NumCalculationRuns = factTask.NumCalculationRuns,
+                       NumRetries = factTask.NumRetries,
+                       CoresRequired = factTask.CoresRequired,
+                       MemoryRequired = factTask.MemoryRequired,
+                       Priority = factTask.Priority,
+                       State = factTask.TaskState.ToString(),
+                       LastClientId = factTask.LastClientId,
+                       LastClientName = a != null ? a.Name : string.Empty,
+                       UserId = isAdministrator ? dimJob.UserId : default(Guid),
+                       UserName = isAdministrator ? dimJob.UserName : string.Empty,
+                       StartTime = factTask.StartTime,
+                       EndTime = factTask.EndTime,
+                       Exception = isAdministrator ? factTask.Exception : string.Empty
+                     })
+                  .OrderByDescending(x => x.EndTime)
+                  .Skip((page - 1) * size)
+                  .Take(size)
+                  .ToList()
+          };
+        });
+      }
+    }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs	(revision 12516)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+
+  [Authorize(Roles = HiveRoles.Administrator)]
+  public class UserController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public IEnumerable<DT.User> GetUsers() {
+      using (var pm = PersistenceManager) {
+        var dimUserDao = pm.DimUserDao;
+        return pm.UseTransaction(() => {
+          return dimUserDao.GetAll().Select(x => new DT.User {
+            Id = x.UserId,
+            Name = x.Name
+          }).ToList();
+        });
+      }
+    }
+
+    public DT.User GetUser(Guid id) {
+      using (var pm = PersistenceManager) {
+        var dimUserDao = pm.DimUserDao;
+        return pm.UseTransaction(() => {
+          var user = dimUserDao.GetById(id);
+          if (user != null) {
+            return new DT.User {
+              Id = user.UserId,
+              Name = user.Name
+            };
+          }
+          return null;
+        });
+      }
+    }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 12515)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 12516)
@@ -1,21 +1,102 @@
 ﻿@using HeuristicLab.Services.Access.DataTransfer
 @using HeuristicLab.Services.Hive
-@if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
 <header class="view-header">
     <ul class="nav nav-list nav-list-topbar pull-left">
-        <li>
-            <a ng-href="#/statistics/jobs">Jobs</a>
-        </li>
+    <li>
+        <a ng-href="#/statistics/jobs">Jobs</a>
+    </li>
+    @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator))
+    {
         <li>
             <a ng-href="#/statistics/users">Users</a>
         </li>
-        <li class="active">
-            <a ng-href="#/statistics/clients">Clients</a>
-        </li>
+    }
+    <li class="active">
+        <a ng-href="#/statistics/clients">Clients</a>
+    </li>
     </ul>
 </header>
 
 <div class="default-view-container">
+    <div class="row">
+        <div class="col-lg-12">
+            <div class="panel panel-default">
+                <div class="panel-heading">
+                    <h3 class="panel-title">Current Clients</h3>
+                </div>
+                <div class="panel-body">
+                    <table class="table table-hover table-condensed">
+                        <thead>
+                        <tr>
+                            <th>#</th>
+                            <th>Client Name</th>
+                            <th>Cores</th>
+                            <th>Cpu Utilization</th>
+                            <th>State</th>
+                            <th></th>
+                        </tr>
+                        </thead>
+                        <tr ng-repeat="client in clientPage.Clients">
+                            <td>{{($index + 1)+((curClientsPage-1)*(clientsPageSize))}}</td>
+                            <td>{{client.Name}}</td>
+                            <td>{{client.UsedCores}} / {{client.TotalCores}}</td>
+                            <td>{{client.CpuUtilization | number: 2}} %</td>
+                            <td>{{client.State}}</td>
+                            <td>
+                                <a ng-href="#/statistics/clients/{{client.Id}}">Details</a>
+                            </td>
+                        </tr>
+                        <tr ng-hide="clientPage.Clients.length">
+                            <td colspan="6" class="text-center">No clients found!</td>
+                        </tr>
+                    </table>
+                    <div class="row text-center" ng-show="clientPage.TotalClients > clientPage.Clients.length">
+                        <pagination max-size="10" total-items="clientPage.TotalClients" ng-model="curClientsPage" ng-change="changeClientsPage()" items-per-page="clientsPageSize"
+                                    boundary-links="true" rotate="false" num-pages="numPages"></pagination>
+                    </div>
+                </div>
+            </div>
+        </div>
+    </div>
 
+    <div class="row">
+        <div class="col-lg-12">
+            <div class="panel panel-default">
+                <div class="panel-heading">
+                    <h3 class="panel-title">Expired Clients</h3>
+                </div>
+                <div class="panel-body">
+                    <table class="table table-hover table-condensed">
+                        <thead>
+                            <tr>
+                                <th>#</th>
+                                <th>Client Name</th>
+                                <th>Cores</th>
+                                <th>Cpu Utilization</th>
+                                <th>State</th>
+                                <th></th>
+                            </tr>
+                        </thead>
+                        <tr ng-repeat="client in expiredClientPage.Clients">
+                            <td>{{($index + 1)+((curExpiredClientsPage-1)*(expiredClientsPageSize))}}</td>
+                            <td>{{client.Name}}</td>
+                            <td>{{client.UsedCores}} / {{client.TotalCores}}</td>
+                            <td>{{client.CpuUtilization | number: 2}} %</td>
+                            <td>{{client.State}}</td>
+                            <td>
+                                <a ng-href="#/statistics/clients/{{client.Id}}">Details</a>
+                            </td>
+                        </tr>
+                        <tr ng-hide="expiredClientPage.Clients.length">
+                            <td colspan="6" class="text-center">No expired clients found!</td>
+                        </tr>
+                    </table>
+                    <div class="row text-center" ng-show="expiredClientPage.TotalClients > expiredClientPage.Clients.length">
+                        <pagination max-size="10" total-items="expiredClientPage.TotalClients" ng-model="curExpiredClientsPage" ng-change="changeExpiredClientsPage()" items-per-page="expiredClientsPageSize"
+                                    boundary-links="true" rotate="false" num-pages="numPages"></pagination>
+                    </div>
+                </div>
+            </div>
+        </div>
+    </div>
 </div>
-}
